//+------------------------------------------------------------------+
//|                                         TEST_FileWriteStruct.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

#include <stderror.mqh>

struct ORD {
    int      OINDEX;      // INDEX
    int      OTICKET;     // OrderTicket
    string   OSYMBOL;     // OrderSymbol
    int      OTYPE;       // OrderType
    double   OOP;         // OrderOpenPrice
    datetime OOT;         // OrderOpenTime
    double   OLOTS;       // OrderLots
    double   OSL;         // OrderStopLoss
    double   OTP;         // OrderTakeProfit
    double   OPROFIT;     // OrderProfit
    double   OCP;         // OrderClosePrice
    datetime OCT;         // OrderCloseTime
    double   OCOMMISSION; // OrderCommission
    double   OSWAP;       // OrdeSwap    
    int      OMN;         // OrderMagicNumber
    datetime OEXPIRATION; // OrderExpiration
    string   OCOMMENT;    // OrderComment
    double   OMLP;        // OrderMinLotPrice 
    double   OMPP;        // OrderMaxProfitPrice
};
ORD          Orders[];

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart(){
   for (int  i = 0; i < OrdersTotal(); i++){
      if (OrderSelect( i, SELECT_BY_POS, MODE_TRADES )){
        Orders[i].OINDEX      = i;
        Orders[i].OTICKET     = OrderTicket(); 
        Orders[i].OSYMBOL     = OrderSymbol();
        Orders[i].OTYPE       = OrderType();
        Orders[i].OOP         = OrderOpenPrice();
        Orders[i].OOT         = OrderOpenTime();
        Orders[i].OLOTS       = OrderLots();
        Orders[i].OSL         = OrderStopLoss();
        Orders[i].OTP         = OrderTakeProfit();
        Orders[i].OPROFIT     = OrderProfit();
        Orders[i].OCP         = OrderClosePrice();
        Orders[i].OCT         = OrderCloseTime();
        Orders[i].OCOMMISSION = OrderCommission();
        Orders[i].OSWAP       = OrderSwap();
        Orders[i].OMN         = OrderMagicNumber();
        Orders[i].OEXPIRATION = OrderExpiration();
        Orders[i].OCOMMENT    = OrderComment();
       }
   }  
  
  //  1.   
  FWS( Orders );
  
  //  2.  
  int i,FWS, FD;
  FD = FileOpen( "Orders.dat", FILE_READ|FILE_WRITE|FILE_BIN );
  for( i = 0; i < ArraySize( Orders ); i++ ){ 
    FWS = FileWriteStruct ( FD, Orders[i]);          //   'Orders' - parameter conversion not allowed	TEST_FileWriteStruct.mq4	69	33
  }
  FileClose(FD);
  
  //  3.  
  FD = FileOpen( "Orders.dat", FILE_READ|FILE_WRITE|FILE_BIN );
  FWS = FileWriteStruct ( FD, Orders );          //   'Orders' - parameter conversion not allowed	TEST_FileWriteStruct.mq4	69	33
  FileClose(FD);


}
//+------------------------------------------------------------------+[SCR END]


//   
void FWS( ORD &l_ord[] ){
  int i,FWS, FD;
  FD = FileOpen( "Orders.dat", FILE_READ|FILE_WRITE|FILE_BIN|FILE_COMMON );
  for( i = 0; i < ArraySize( l_ord ); i++ ){ 
      FWS = FileWriteStruct ( FD, l_ord[i]); //   'l_ord' - parameter conversion not allowed	TEST_FileWriteStruct.mq4	81	35
  }
  FileClose(FD);
}

